<?php
	// yapb-post-file.php v0.1-2013/08/14
	// by sk@pn.org (http://pn.org/wordpress/)

// BEGIN CONFIG
	require( "yapb-post-file.config.php" );
// END CONFIG



// BEGIN WORDPRESS FUNCTIONS

	function wpRequest( $method, $params, $http_user = "", $http_pass = "" ) {
		$request = xmlrpc_encode_request( $method, $params );

		//HACK: Workaround for
		//		Fatal error: Call to a member function getIso() on a non-object in /var/www/wp-includes/class-wp-xmlrpc-server.php on line 2373
		//  	when setting dateCreated or date_created_gmt

		$request = preg_replace( "/(<member>\s*<name>dateCreated<\/name>\s*<value>\s*)<string>([^<]*)<\/string>(\s*<\/value>\s*<\/member>)/",
					"$1<dateTime.iso8601>$2</dateTime.iso8601>$3",
					$request );
		$request = preg_replace( "/(<member>\s*<name>date_created_gmt<\/name>\s*<value>\s*)<string>([^<]*)<\/string>(\s*<\/value>\s*<\/member>)/",
					"$1<dateTime.iso8601>$2</dateTime.iso8601>$3",
					$request );

		$ch = curl_init();
		curl_setopt($ch, CURLOPT_POSTFIELDS, $request);
		curl_setopt($ch, CURLOPT_URL, RPC_URL );
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_TIMEOUT, 5);
		if( !empty( $http_user ) ) {
			curl_setopt( $ch, CURLOPT_USERPWD, $http_user.":".$http_pass );	
		}
		$data = curl_exec($ch);
		$info = curl_getinfo( $ch );
		if( curl_errno( $ch ) ) {
			echo "wpRequest: ".curl_error($ch)."\n";
		} else {
			if( $info['http_code'] >= 400 ) { 
				echo "wpRequest: fetch was not successful:\n";
				print_r( $info );
			}
		}
		curl_close($ch);

		if( !empty( $data ) )
			return xmlrpc_decode($data);
		
		return false;
	}

	class wp_struct_content {
		var $wp_slug;
		var $wp_password;
		var $wp_page_parent_id;
		var $wp_page_order;
		var $wp_author_id;
		var $title;
		var $description;	// (content of post)
		var $categories;	// type: array
		var $mt_excerpt;
		var $mt_text_more;
		var $mt_allow_comments;	// (0 = closed, 1 = open)
		var $mt_allow_pings; 	//(0 = closed, 1 = open)
		var $mt_keywords; 	// (tags)
		var $dateCreated;
		var $custom_fields;
	}

	function wpNewPost( $content, $wp_user, $wp_pass, $http_user, $http_pass ) {
		$params = array(1,$wp_user,$wp_pass,$content,true);	// blogid(ignored),username,password,content
		
		$res = wpRequest( "metaWeblog.newPost", $params, $http_user, $http_pass );

		if( is_array( $res ) ) {
			var_dump( $res );
			return false;
		}

		return intval($res);	// postid as string 
	}

	function wpGetPost( $postid, $wp_user, $wp_pass, $http_user, $http_pass ) {
		$params = array($postid,$wp_user,$wp_pass,true);	// postid,username,password,content
		
		$res = wpRequest( "metaWeblog.getPost", $params, $http_user, $http_pass );

		return $res;	// array 
	}

	function wpEditPost( $postid, $content, $wp_user, $wp_pass, $http_user, $http_pass ) {
		$params = array($postid,$wp_user,$wp_pass,$content,true);	// postid,username,password,content
		
		$res = wpRequest( "metaWeblog.editPost", $params, $http_user, $http_pass );

		if( is_array( $res ) ) {
			var_dump( $res );
			return false;
		}

		return $res;	// status as bool
	}

// END WORDPRESS FUNCTIONS


// BEGIN PHOTO FUNCTIONS

	function get_iptc_info( $filename ) {
		$size = getimagesize( $filename, $info );
		if( isset($info['APP13']) ) {
		    	$iptc = iptcparse($info['APP13']);
			return $iptc;
		}
		return false;
	}

	function get_exif_info( $filename ) {
		$exif_ifd0 = read_exif_data( $filename, "IFD0", false, false );
	      	$exif_exif = read_exif_data( $filename, "EXIF", false, false );

		if( is_array( $exif_ifd0 ) &&
		    is_array( $exif_exif ) ) {
		    return array_merge( $exif_ifd0, $exif_exif );
		} else if( is_array( $exif_ifd0 ) ) {
			return $exif_ifd0;
		} else if( is_array( $exif_exif ) ) {
			return $exif_exif; 
		}
	
		return false;
	}

// END PHOTO FUNCTIONS


	function yapbNewPost( $filename, $category, $tags, 
			      $wp_author_id = WP_AUTHOR_ID,
			      $wp_user = WP_USER, $wp_pass = WP_PASS, 
			      $mysql_host = MYSQL_HOST, $mysql_db = MYSQL_DB, $mysql_user = MYSQL_USER, $mysql_pass = MYSQL_PASS,
			      $site_root = YAPB_SITE_ROOT, $upload_dir = YAPB_UPLOAD_DIR,
			      $wp_http_user = WP_HTTP_USER, $wp_http_pass = WP_HTTP_PASS ) {
		$wp_mysql_link = mysql_connect( $mysql_host, $mysql_user, $mysql_pass );
		if( $wp_mysql_link === false ) {
			echo "Error: Failed to connect to MySQL Database Server: ".mysql_error()."\n";
			return false;
		}
		if( mysql_select_db( $mysql_db, $wp_mysql_link ) === false ) {
			echo "Error: Failed to select MySQL Database '".mysql_db."': ".mysql_error( $wp_mysql_link )."\n";
			return false;
		}
		
		echo "* DB Connect OK\n";

		// get exif/iptc info for post...
		echo "* Reading EXIF/IPTC tags...\n";
		$exif = get_exif_info( $filename );
		$iptc = get_iptc_info( $filename );
		$DateTimeOriginal = $exif['DateTimeOriginal'];
		if( isset( $exif['COMMENT'] ) ) {
			$Comment = $exif['COMMENT'][0];
		} else {
			$Comment = "";
		}
		echo "* Tag 'DateTimeOriginal' = ".$DateTimeOriginal."\n";
		echo "* Tag 'Comment' = ".$Comment."\n";

                $pi = pathinfo( $filename );
                $Title = str_replace( array("-","_"), " ", $pi['filename'] );

		// create a new post (we need the post id)...
		echo "* Creating new post...\n"; 
		$post_content = new wp_struct_content();
		$post_content->title = $Title; 
		$post_content->description = $Comment;
		$post_content->categories = array();
		$post_content->categories[] = $category;
		$post_content->mt_keywords = $tags;
		$post_content->wp_author_id = $wp_author_id;
		$post_content->dateCreated = preg_replace( "/(\d{4}):(\d{2}):(\d{2}) (\d{2}):(\d{2}):(\d{2})/",
								"$1$2$3T$4:$5:$6Z",
								$DateTimeOriginal ); 
		//var_dump( $post_content );
		$post_id = wpNewPost( $post_content, $wp_user, $wp_pass, $wp_http_user, $wp_http_pass );
		if( $post_id <= 0 ) {
			echo "Error: Failed to create new Wordpres post.\n";
			return false;
		}
		echo "* New Post ID: $post_id\n";

		echo "* Retrieving new post ".$post_id."...\n";
		$post_content = wpGetPost( $post_id, $wp_user, $wp_pass, $wp_http_user, $wp_http_pass );
		if( $post_content === false ) {
			echo "Error: Failed to retrieve new Wordpress post (ID ".$post_id.") for update - ORPHAN POST!\n";
			return false;
		}
		//print_r( $post_content );
		echo "* Retrieved Post ID ".$post_id." for update.\n";

		// create filename relative to site root..
		$filename_rel = trim($upload_dir)."/".basename(trim($filename));
		$filename_abs = trim($site_root).trim($upload_dir)."/".basename(trim($filename));	// upload_dir has to start with a slash

		// copy file to upload dir...
		echo "* Copying file '$filename' to '$filename_abs'...\n";
		$copy_ret = copy( $filename, $filename_abs );
		if( $copy_ret === false ) {
			//FIXME: automatically delete the post?
			echo "Error: Failed to copy file '".$filename."' to upload dir (as '".$filename_abs."') - ORPHAN POST (".$post_id.")!\n";
			return false;
		}

		// create new row in wp_yapbimage...
		echo "* Adding yapbimage row for '".$filename_rel."' (".$post_id.")...\n"; 
		$query = sprintf( "INSERT INTO `wp_yapbimage` VALUES (0,%d,'%s')",
				$post_id,
				mysql_escape_string( $filename_rel ) );
		if( mysql_query( $query, $wp_mysql_link ) === false ) {
			//FIXME: automatically delete the post and file?
			echo "Error: Failed query '$query': ".mysql_error($wp_mysql_link)." - ORPHAN POST (".$post_id."), ORPHAN FILE ('".$filenamei_abs."')!\n";
			return false;
		}

		// new that the image is associated with the post,
		// we update the post to trigger associated actions by other plugins...
		echo "* Updateing post ".$post_id."...\n";
		//$post_content->menu_order = $post_id;	// to set the order to 'order of creation' - since the post creation date is set to the exif timestamp
		$update_ret = wpEditPost( $post_id, $post_content, $wp_user, $wp_pass, $wp_http_user, $wp_http_pass );
		if( $update_ret == false ) {
			echo "Warning: Failed to update post ID ".$post_id." - Handlers for plugins not triggered. You might need to update the post manually!\n"; 
		}

		return true;
	}
	
	if( $argc < 4 ) {
		echo "syntax: ".$argv[0]." <category> <tags> <filename>\n";
		exit;
	}

	yapbNewPost( $argv[3], $argv[1], $argv[2] ); 
?>
